﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Pivot.Core;

namespace RadPivotGrid_SL_843143
{
    public class HalfYearGroupDescription : PropertyGroupDescriptionBase
    {
        protected override object GroupNameFromItem(object item, int level)
        {
            var order = item as Order;
            if (order != null)
            {
                var date = order.Date;
                if (date.Month <= 6)
                {
                    return string.Format("{0} H1", date.Year);
                }
                else
                {
                    return string.Format("{0} H2", date.Year);
                }
            }

            return base.GroupNameFromItem(item, level);
        }

        protected override void CloneOverride(Cloneable source)
        {
            // Copy all properties from source to this
        }

        protected override Cloneable CreateInstanceCore()
        {
            return new HalfYearGroupDescription();
        }
    }
}
