﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Net;
using System.Reflection;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Pivot.Core;
using Telerik.Pivot.Core.Fields;

namespace RadPivotGrid_SL_843143
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Raised when the user adds description from the top part of RadPivotFieldList.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LocalDataSourceProvider_PrepareDescriptionForField(object sender, PrepareDescriptionForFieldEventArgs e)
        {
            if (e.DescriptionType == DataProviderDescriptionType.Group)
            {
                var description = e.Description as PropertyGroupDescriptionBase;
                if (description != null && e.FieldInfo.DisplayName == "Date - Half Year")
                {
                    e.Description = new HalfYearGroupDescription() { PropertyName = "Date", CustomName = "Date - Half Year" };
                }
            }
        }

        /// <summary>
        /// Raised when the initialization of the FieldInfos (shown in the top part of RadPivotFieldList as checkboxes and folders) has finished.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void LocalDataSourceFieldDescriptionsProvider_GetDescriptionsDataAsyncCompleted(object sender, Telerik.Pivot.Core.Fields.GetDescriptionsDataCompletedEventArgs e)
        {
            var rootItem = e.DescriptionsData.RootFieldInfo;
            var dateGroup = rootItem.Children.FirstOrDefault(c => c.Caption == "Date");
            // Remove the "normal" Date PropertyGroupDescription
            dateGroup.Children.RemoveAt(dateGroup.Children.Count - 1);

            // Create a new ContainerNode for Date in order to show Date - Half Year in the top part of  RadPivotFieldList
            dateGroup.Children.Add(GenerateHalfYearStep("Date"));
        }

        private ContainerNode GenerateHalfYearStep(string propertyName)
        {
            var order = new Order();
            var info = new PropertyInfoFieldInfo(typeof(Order).GetProperty(propertyName));

            info.Name = propertyName;
            info.DisplayName = string.Format(CultureInfo.InvariantCulture, "{0} - {1}", propertyName, "Half Year");
            info.PreferredRole = FieldRoles.Row;
            info.AllowedRoles = FieldRoles.Row | FieldRoles.Column;
            info.AutoGenerateField = true;
            var fieldInfo = new FieldInfoNode(info);

            return fieldInfo;
        }
    }
}
